package handler_test

import (
	"encoding/json"
	"fmt"
	"testing"
	"time"

	"github.com/stretchr/testify/assert"
	"sensorbucket.nl/sensorbucket/pkg/pipeline"
	"sensorbucket.nl/workers/ttn-source-worker/internal/device_service"
	"sensorbucket.nl/workers/ttn-source-worker/internal/handler"
)

func Test_Handle(t *testing.T) {
	h := handler.New(device_service.DeviceService{Endpoint: ""})
	for _, data := range testData {
		model := pipeline.Message{
			ID:         "blabla",
			PipelineID: "blabla",
			// MessageId:  "blabla",
			// PipelineId: "asd",
			PipelineSteps: []string{
				"next_queue",
				"next_next_queue",
			},
			Timestamp: time.Now().Unix(),
			Payload:   data.input,
		}
		b, _ := json.Marshal(model)
		topic, res, err := h.Handle(b)
		assert.Nil(t, err)
		//assert.Equal(t, data.expected, string(res))
		fmt.Println("RESULT", string(res))
		assert.Equal(t, "next_queue", topic)
	}
}

type testCase struct {
	input    string
	expected []byte
}

var testData = []testCase{
	{
		input:    `{"result":{"end_device_ids":{"device_id":"eui-70b3d57ed004843b","application_ids":{"application_id":"multiflexmeter-peilbuis"},"dev_eui":"70B3D57ED004843B","dev_addr":"260B886F"},"received_at":"2022-03-29T17:08:09.603016213Z","uplink_message":{"f_port":1,"f_cnt":2921,"frm_payload":"bBGBDkMBX84=","rx_metadata":[{"gateway_ids":{"gateway_id":"zierikzee","eui":"FCC23DFFFE0AA792"},"time":"2022-03-29T17:08:09.372731924Z","timestamp":3701780100,"rssi":-113,"channel_rssi":-113,"snr":3.25,"location":{"latitude":51.64737625928004,"longitude":3.9316999912261967,"altitude":50,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"pz7kats","eui":"FCC23DFFFE0B76E5"},"time":"2022-03-29T17:08:09.341686010Z","timestamp":3932333644,"rssi":-105,"channel_rssi":-105,"snr":10.25,"location":{"latitude":51.59383557233384,"longitude":3.868775367736817,"altitude":85,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"goes","eui":"FCC23DFFFE0AA6E3"},"time":"2022-03-29T17:08:09.374856Z","timestamp":863582924,"rssi":-105,"channel_rssi":-105,"snr":-3.2,"location":{"latitude":51.51081407756074,"longitude":3.884471654891968,"altitude":83,"source":"SOURCE_REGISTRY"}}],"settings":{"data_rate":{"lora":{"bandwidth":125000,"spreading_factor":9}},"coding_rate":"4/5","frequency":"868100000","timestamp":3701780100,"time":"2022-03-29T17:08:09.372731924Z"},"received_at":"2022-03-29T17:08:09.392055550Z","consumed_airtime":"0.185344s","locations":{"user":{"latitude":51.584167597612726,"longitude":3.8271555304527287,"altitude":1,"source":"SOURCE_REGISTRY"}},"network_ids":{"net_id":"000013","tenant_id":"ttn","cluster_id":"ttn-eu1"}}}}`,
		expected: []byte(`{"message_id":"blabla","pipeline_id":"asd","pipeline_steps":["next_queue"],"device":{},"timestamp":1663514157,"measurements":[{"value":-113,"properties":{"gw_eui":"FCC23DFFFE0AA792","gw_id":"zierikzee"},"measurement_type_id":"rssi"},{"value":3.25,"properties":{"gw_eui":"FCC23DFFFE0AA792","gw_id":"zierikzee"},"measurement_type_id":"snr"},{"value":-105,"properties":{"gw_eui":"FCC23DFFFE0B76E5","gw_id":"pz7kats"},"measurement_type_id":"rssi"},{"value":10.25,"properties":{"gw_eui":"FCC23DFFFE0B76E5","gw_id":"pz7kats"},"measurement_type_id":"snr"},{"value":-105,"properties":{"gw_eui":"FCC23DFFFE0AA6E3","gw_id":"goes"},"measurement_type_id":"rssi"},{"value":-3.2,"properties":{"gw_eui":"FCC23DFFFE0AA6E3","gw_id":"goes"},"measurement_type_id":"snr"}],"payload":"YkJHQkRrTUJYODQ9"}`),
	},
	{
		input:    `{"result":{"end_device_ids":{"device_id":"eui-70b3d57ed004843e","application_ids":{"application_id":"multiflexmeter-peilbuis"},"dev_eui":"70B3D57ED004843E","dev_addr":"260B7F2F"},"received_at":"2022-03-29T14:41:37.895511252Z","uplink_message":{"f_cnt":3057,"rx_metadata":[{"gateway_ids":{"gateway_id":"pz7kats","eui":"FCC23DFFFE0B76E5"},"time":"2022-03-29T14:41:37.620647907Z","timestamp":3730532956,"rssi":-105,"channel_rssi":-105,"snr":-8,"location":{"latitude":51.59383557233384,"longitude":3.868775367736817,"altitude":85,"source":"SOURCE_REGISTRY"}}],"settings":{"data_rate":{"lora":{"bandwidth":125000,"spreading_factor":8}},"coding_rate":"4/5","frequency":"868500000","timestamp":3730532956,"time":"2022-03-29T14:41:37.620647907Z"},"received_at":"2022-03-29T14:41:37.686094136Z","consumed_airtime":"0.082432s","locations":{"user":{"latitude":51.68269833206993,"longitude":3.8384905457496648,"altitude":1,"source":"SOURCE_REGISTRY"}},"network_ids":{"net_id":"000013","tenant_id":"ttn","cluster_id":"ttn-eu1"}}}}`,
		expected: []byte(`{"message_id":"blabla","pipeline_id":"asd","pipeline_steps":["next_queue"],"device":{},"timestamp":1663514240,"measurements":[{"value":-105,"properties":{"gw_eui":"FCC23DFFFE0B76E5","gw_id":"pz7kats"},"measurement_type_id":"rssi"},{"value":-8,"properties":{"gw_eui":"FCC23DFFFE0B76E5","gw_id":"pz7kats"},"measurement_type_id":"snr"}],"payload":""}`),
	},
	{
		input:    `{"result":{"end_device_ids":{"device_id":"eui-70b3d57ed0048440","application_ids":{"application_id":"multiflexmeter-peilbuis"},"dev_eui":"70B3D57ED0048440","dev_addr":"260B04BA"},"received_at":"2022-03-29T09:01:45.662513950Z","uplink_message":{"f_port":1,"f_cnt":2039,"frm_payload":"bBEDLVQ=","rx_metadata":[{"gateway_ids":{"gateway_id":"zierikzee","eui":"FCC23DFFFE0AA792"},"time":"2022-03-29T09:01:45.391844987Z","timestamp":2308789444,"rssi":-116,"channel_rssi":-116,"snr":2,"location":{"latitude":51.64737625928004,"longitude":3.9316999912261967,"altitude":50,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"goes","eui":"FCC23DFFFE0AA6E3"},"time":"2022-03-29T09:01:45.433934Z","timestamp":1744410292,"rssi":-107,"channel_rssi":-107,"snr":5.2,"location":{"latitude":51.51081407756074,"longitude":3.884471654891968,"altitude":83,"source":"SOURCE_REGISTRY"},"channel_index":7},{"gateway_ids":{"gateway_id":"skyhigh-goes","eui":"FCC23DFFFE2DF1CA"},"time":"2022-03-29T09:01:45.440327882Z","timestamp":312083428,"rssi":-111,"channel_rssi":-111,"snr":8.25,"location":{"latitude":51.51081140775607,"longitude":3.884471654891968,"altitude":83,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"pz7kats","eui":"FCC23DFFFE0B76E5"},"time":"2022-03-29T09:01:45.378782987Z","timestamp":280416148,"rssi":-97,"channel_rssi":-97,"snr":9.75,"location":{"latitude":51.59383557233384,"longitude":3.868775367736817,"altitude":85,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"pz9stmaartensdijk","eui":"FCC23DFFFE2EE75A"},"time":"2022-03-29T09:01:45.391088008Z","timestamp":3030568916,"rssi":-103,"channel_rssi":-103,"snr":8.75,"location":{"latitude":51.56747735530653,"longitude":4.038240015506745,"altitude":78,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"pz4goes","eui":"FCC23DFFFE0B8715"},"time":"2022-03-29T09:01:45.294476985Z","timestamp":2621924148,"rssi":-119,"channel_rssi":-119,"snr":-7,"location":{"latitude":51.500077591146876,"longitude":3.906251192092896,"altitude":15,"source":"SOURCE_REGISTRY"}}],"settings":{"data_rate":{"lora":{"bandwidth":125000,"spreading_factor":7}},"coding_rate":"4/5","frequency":"867900000","timestamp":2308789444,"time":"2022-03-29T09:01:45.391844987Z"},"received_at":"2022-03-29T09:01:45.450678088Z","consumed_airtime":"0.051456s","locations":{"user":{"latitude":51.561348719651576,"longitude":3.8959300518035893,"altitude":1,"source":"SOURCE_REGISTRY"}},"network_ids":{"net_id":"000013","tenant_id":"ttn","cluster_id":"ttn-eu1"}}}}`,
		expected: []byte(`{"message_id":"blabla","pipeline_id":"asd","pipeline_steps":["next_queue"],"device":{},"timestamp":1663514157,"measurements":[{"value":-111,"properties":{"gw_eui":"FCC23DFFFE0AA792","gw_id":"zierikzee"},"measurement_type_id":"rssi"},{"value":5,"properties":{"gw_eui":"FCC23DFFFE0AA792","gw_id":"zierikzee"},"measurement_type_id":"snr"},{"value":-109,"properties":{"gw_eui":"FCC23DFFFE2EE75A","gw_id":"pz9stmaartensdijk"},"measurement_type_id":"rssi"},{"value":6.25,"properties":{"gw_eui":"FCC23DFFFE2EE75A","gw_id":"pz9stmaartensdijk"},"measurement_type_id":"snr"},{"value":-97,"properties":{"gw_eui":"FCC23DFFFE0B76E5","gw_id":"pz7kats"},"measurement_type_id":"rssi"},{"value":9,"properties":{"gw_eui":"FCC23DFFFE0B76E5","gw_id":"pz7kats"},"measurement_type_id":"snr"}],"payload":"YkJFQVBFRT0="}`),
	},
	{
		input:    `{"result":{"end_device_ids":{"device_id":"eui-70b3d57ed0048441","application_ids":{"application_id":"multiflexmeter-peilbuis"},"dev_eui":"70B3D57ED0048441","dev_addr":"260B84E7"},"received_at":"2022-03-29T05:11:28.466823063Z","uplink_message":{"f_port":1,"f_cnt":2005,"frm_payload":"bBEAPEE=","rx_metadata":[{"gateway_ids":{"gateway_id":"zierikzee","eui":"FCC23DFFFE0AA792"},"time":"2022-03-29T05:11:28.203577995Z","timestamp":1376506483,"rssi":-111,"channel_rssi":-111,"snr":5,"location":{"latitude":51.64737625928004,"longitude":3.9316999912261967,"altitude":50,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"pz9stmaartensdijk","eui":"FCC23DFFFE2EE75A"},"time":"2022-03-29T05:11:28.196212053Z","timestamp":2098286251,"rssi":-109,"channel_rssi":-109,"snr":6.25,"location":{"latitude":51.56747735530653,"longitude":4.038240015506745,"altitude":78,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"pz7kats","eui":"FCC23DFFFE0B76E5"},"time":"2022-03-29T05:11:28.199781894Z","timestamp":3643101395,"rssi":-97,"channel_rssi":-97,"snr":9,"location":{"latitude":51.59383557233384,"longitude":3.868775367736817,"altitude":85,"source":"SOURCE_REGISTRY"}}],"settings":{"data_rate":{"lora":{"bandwidth":125000,"spreading_factor":7}},"coding_rate":"4/5","frequency":"867100000","timestamp":1376506483,"time":"2022-03-29T05:11:28.203577995Z"},"received_at":"2022-03-29T05:11:28.256812135Z","consumed_airtime":"0.051456s","locations":{"user":{"latitude":51.56130870045453,"longitude":3.8950717449188237,"altitude":1,"source":"SOURCE_REGISTRY"}},"network_ids":{"net_id":"000013","tenant_id":"ttn","cluster_id":"ttn-eu1"}}}}`,
		expected: []byte(``),
	},
	{
		input: `{"result":{"end_device_ids":{"device_id":"eui-70b3d57ed0048281","application_ids":{"application_id":"multiflexmeter-peilbuis"},"dev_eui":"70B3D57ED0048281","dev_addr":"260B47D8"},"received_at":"2022-03-29T09:26:10.372193892Z","uplink_message":{"f_port":1,"f_cnt":2092,"frm_payload":"bBECfOo=","rx_metadata":[{"gateway_ids":{"gateway_id":"skyhigh-goes","eui":"FCC23DFFFE2DF1CA"},"time":"2022-03-29T09:26:10.146142005Z","timestamp":1776796556,"rssi":-117,"channel_rssi":-117,"snr":0.25,"location":{"latitude":51.51081140775607,"longitude":3.884471654891968,"altitude":83,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"zierikzee","eui":"FCC23DFFFE0AA792"},"time":"2022-03-29T09:26:10.111741065Z","timestamp":3773501980,"rssi":-104,"channel_rssi":-104,"snr":6.25,"location":{"latitude":51.64737625928004,"longitude":3.9316999912261967,"altitude":50,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"goes","eui":"FCC23DFFFE0AA6E3"},"time":"2022-03-29T09:26:10.151782Z","timestamp":3209122804,"rssi":-113,"channel_rssi":-113,"snr":0.8,"location":{"latitude":51.51081407756074,"longitude":3.884471654891968,"altitude":83,"source":"SOURCE_REGISTRY"},"channel_index":6},{"gateway_ids":{"gateway_id":"pz7kats","eui":"FCC23DFFFE0B76E5"},"time":"2022-03-29T09:26:10.100167036Z","timestamp":1745128596,"rssi":-87,"channel_rssi":-87,"snr":9.25,"location":{"latitude":51.59383557233384,"longitude":3.868775367736817,"altitude":85,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"pz9stmaartensdijk","eui":"FCC23DFFFE2EE75A"},"time":"2022-03-29T09:26:10.101217985Z","timestamp":200314132,"rssi":-106,"channel_rssi":-106,"snr":4.5,"location":{"latitude":51.56747735530653,"longitude":4.038240015506745,"altitude":78,"source":"SOURCE_REGISTRY"}}],"settings":{"data_rate":{"lora":{"bandwidth":125000,"spreading_factor":7}},"coding_rate":"4/5","frequency":"867700000","timestamp":1776796556,"time":"2022-03-29T09:26:10.146142005Z"},"received_at":"2022-03-29T09:26:10.162595499Z","consumed_airtime":"0.051456s","locations":{"user":{"latitude":51.558115722146695,"longitude":3.8901874423027043,"altitude":1,"source":"SOURCE_REGISTRY"}},"network_ids":{"net_id":"000013","tenant_id":"ttn","cluster_id":"ttn-eu1"}}}}`,
	},
	{
		input: `{"result":{"end_device_ids":{"device_id":"eui-70b3d57ed0048440","application_ids":{"application_id":"multiflexmeter-peilbuis"},"dev_eui":"70B3D57ED0048440","dev_addr":"260B04BA"},"received_at":"2022-03-29T07:02:09.528187803Z","uplink_message":{"f_port":1,"f_cnt":2037,"frm_payload":"bBEDLS8=","rx_metadata":[{"gateway_ids":{"gateway_id":"skyhigh-goes","eui":"FCC23DFFFE2DF1CA"},"time":"2022-03-29T07:02:09.293970108Z","timestamp":1725887331,"rssi":-106,"channel_rssi":-106,"snr":4.25,"location":{"latitude":51.51081140775607,"longitude":3.884471654891968,"altitude":83,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"goes","eui":"FCC23DFFFE0AA6E3"},"time":"2022-03-29T07:02:09.305191Z","timestamp":3158216227,"rssi":-109,"channel_rssi":-109,"snr":3,"location":{"latitude":51.51081407756074,"longitude":3.884471654891968,"altitude":83,"source":"SOURCE_REGISTRY"},"channel_index":2},{"gateway_ids":{"gateway_id":"pz7kats","eui":"FCC23DFFFE0B76E5"},"time":"2022-03-29T07:02:09.251929044Z","timestamp":1694222419,"rssi":-99,"channel_rssi":-99,"snr":5.5,"location":{"latitude":51.59383557233384,"longitude":3.868775367736817,"altitude":85,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"pz9stmaartensdijk","eui":"FCC23DFFFE2EE75A"},"time":"2022-03-29T07:02:09.257085084Z","timestamp":149407595,"rssi":-100,"channel_rssi":-100,"snr":6.75,"location":{"latitude":51.56747735530653,"longitude":4.038240015506745,"altitude":78,"source":"SOURCE_REGISTRY"}},{"gateway_ids":{"gateway_id":"pz4goes","eui":"FCC23DFFFE0B8715"},"time":"2022-03-29T07:02:09.166887998Z","timestamp":4035733587,"rssi":-116,"channel_rssi":-116,"snr":-8.5,"location":{"latitude":51.500077591146876,"longitude":3.906251192092896,"altitude":15,"source":"SOURCE_REGISTRY"}}],"settings":{"data_rate":{"lora":{"bandwidth":125000,"spreading_factor":7}},"coding_rate":"4/5","frequency":"868500000","timestamp":1725887331,"time":"2022-03-29T07:02:09.293970108Z"},"received_at":"2022-03-29T07:02:09.312816747Z","consumed_airtime":"0.051456s","locations":{"user":{"latitude":51.561348719651576,"longitude":3.8959300518035893,"altitude":1,"source":"SOURCE_REGISTRY"}},"network_ids":{"net_id":"000013","tenant_id":"ttn","cluster_id":"ttn-eu1"}}}}`,
	},
}
